# Record Class LLDatabaseRUD

java.lang.Object
java.lang.Record
com.io7m.looseleaf.database.api.LLDatabaseRUD

Record Components:
  `read` - The keys to read
  `update` - The keys to update
  `delete` - The keys to delete

public record LLDatabaseRUD(Set<LLKeyName> read, Map<LLKeyName, String> update, Set<LLKeyName> delete) extends Record
A transactional read-update-delete operation. First, all keys in `read` will be read, then all keys in `update` will be updated, and finally all keys in `delete` will be deleted.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LLDatabaseRUD(Set<LLKeyName> read, Map<LLKeyName, String> update, Set<LLKeyName> delete)`
  A transactional read-update-delete operation.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Set<LLKeyName>`
  `delete()`
  Returns the value of the `delete` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `Set<LLKeyName>`
  `read()`
  Returns the value of the `read` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `Map<LLKeyName, String>`
  `update()`
  Returns the value of the `update` record component.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### LLDatabaseRUD

    public LLDatabaseRUD(Set<LLKeyName> read, Map<LLKeyName, String> update, Set<LLKeyName> delete)
    A transactional read-update-delete operation. First, all keys in `read` will be read, then all keys in `update` will be updated, and finally all keys in `delete` will be deleted.
    Parameters:
      `read` - The keys to read
      `update` - The keys to update
      `delete` - The keys to delete

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### read

    public Set<LLKeyName> read()
    Returns the value of the `read` record component.
    Returns:
      the value of the `read` record component

  - ### update

    public Map<LLKeyName, String> update()
    Returns the value of the `update` record component.
    Returns:
      the value of the `update` record component

  - ### delete

    public Set<LLKeyName> delete()
    Returns the value of the `delete` record component.
    Returns:
      the value of the `delete` record component